package shells

import (
	"crypto/rand"
	"encoding/binary"
)

var keySize = 5

func randUint32() uint32 {
	b := make([]byte, 4096)
	if _, err := rand.Read(b); err != nil {

		panic(err)
	}
	return binary.BigEndian.Uint32(b)
}

const charset = "abcdefghijklmnopqrstuvwxyz1234567890"

func keygen() string {
	gen := func() string {
		chrlen := len(charset)
		b := make([]byte, keySize)
		for i := 0; i != keySize; i++ {
			b[i] = charset[randUint32()%uint32(chrlen)]
		}
		return string(b)
	}
	id := gen()
	_, ok := srv.Map[id]
	for ok {
		log.Debug().Msg("id taken, cycling")
		id = gen()
	}
	return id
}
