package shells

import (
	"fmt"

	"git.tcp.direct/kayos/sh3lly/chat"
	"git.tcp.direct/kayos/sh3lly/chat/message"
)

func (c *Client) ID() string {
	return c.id
}

func (c *Client) Name() string {
	return c.id
}

func (c *Client) SetID(new string) {
	if _, ok := srv.Map[new]; ok {
		msg := fmt.Sprintf("[%s] %s", c.ID(), "ID is taken")
		chat.ExternalAnnouncements <- message.NewAnnounceMsg(msg)
		return
	}
	c.id = new

}
